#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum MagnitudeScaling {
    /// Linear scaling of the magnitude.
    #[serde(rename = "LINEAR")]
    Linear,
    /// Scales the magnitude via 10 * log10(magnitude).
    #[serde(rename = "MAGNITUDE_DB_10")]
    MagnitudeDb10,
    /// Scales the magnitude via 20 * log10(magnitude).
    #[serde(rename = "MAGNITUDE_DB_20")]
    MagnitudeDb20,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl MagnitudeScaling {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            MagnitudeScaling::Linear => "LINEAR",
            MagnitudeScaling::MagnitudeDb10 => "MAGNITUDE_DB_10",
            MagnitudeScaling::MagnitudeDb20 => "MAGNITUDE_DB_20",
            MagnitudeScaling::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for MagnitudeScaling {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for MagnitudeScaling {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for MagnitudeScaling {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<MagnitudeScaling, conjure_object::plain::ParseEnumError> {
        match v {
            "LINEAR" => Ok(MagnitudeScaling::Linear),
            "MAGNITUDE_DB_10" => Ok(MagnitudeScaling::MagnitudeDb10),
            "MAGNITUDE_DB_20" => Ok(MagnitudeScaling::MagnitudeDb20),
            v => v.parse().map(|v| MagnitudeScaling::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for MagnitudeScaling {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<MagnitudeScaling, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the MagnitudeScaling enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
